package main

import "fmt"

const n = 15

var studentsArray = [n]struct {
	key   string
	value string
}{
	{"Amdahl, Gene", "USA"}, {"Berners-Lee, Tim", "UK"},
	{"Boole, George", "UK"}, {"Godel, Kurt", "Austria"},
	{"Karp, Richard", "USA"}, {"Knuth, Donald", "USA"},
	{"Leibniz, Gottfried", "Germany"}, {"Makimoto, Tsugio", "Japan"},
	{"Moore, Gordon", "USA"}, {"Torvalds, Linus", "Finland"},
	{"Turing, Alan", "UK"}, {"Von Neumann, John", "Hungary"},
	{"Wu, Wenjun", "China"}, {"Yang, Xiong", "China"},
	{"Yao, Andrew", "China"},
}

func lookup(studentName string) string {
	var low, high, mid int
	low, high = 0, n-1
	for low <= high {
		mid = (low + high) / 2
		if studentName == studentsArray[mid].key {
			return studentsArray[mid].value
		}
		if studentName > studentsArray[mid].key {
			low = mid + 1
		} else {
			high = mid - 1
		}
	}
	return "not found"
}
func main() {
	s, t := "Knuth, Donald", "Babayan, Boris"
	fmt.Println(s, "is from", lookup(s))
	fmt.Println(t, "is", lookup(t))
}
