package main

import "fmt"

type Record struct {
	next           *Record
	studentName    string
	studentCountry string
}

const HashTableSize = 6

var hashTable [HashTableSize]*Record

func hashFunction(name string) int {
	sum := 0
	for i := 0; i < len(name); i++ {
		sum = sum + int(name[i])
	}
	return sum % HashTableSize
}

func lookup(studentName string) string {
	hashIndex := hashFunction(studentName)
	entry := hashTable[hashIndex]
	current := entry
	for current != nil {
		if current.studentName == studentName {
			return current.studentCountry // keys match
		}
		current = current.next // otherwise goto next
	}
	return "not found"
}

var studentsMap = map[string]string{
	"Berners-Lee, Tim": "UK", "Wu, Wenjun": "China",
	"Godel, Kurt": "Austria", "Turing, Alan": "UK",
	"Knuth, Donald": "USA", "Leibniz, Gottfried": "Germany",
	"Von Neumann, John": "Hungary", "Amdahl, Gene": "USA",
	"Yao, Andrew": "China", "Moore, Gordon": "USA",
	"Yang, Xiong": "China", "Karp, Richard": "USA",
	"Boole, George": "UK", "Makimoto, Tsugio": "Japan",
	"Torvalds, Linus": "Finland",
}

func main() {
	for key, value := range studentsMap { // fill out hashTable
		hashIndex := hashFunction(key)
		newRecord := &Record{
			next:           hashTable[hashIndex],
			studentName:    key,
			studentCountry: value,
		}
		hashTable[hashIndex] = newRecord
	}
	s, t := "Knuth, Donald", "Babayan, Boris" // look up s and t
	fmt.Println(s, "is from", lookup(s))
	fmt.Println(t, "is", lookup(t))
}
